if BuildTextures == nil then BuildTextures = {} end
BuildTextures.MAX_ENTRIES_PER_FOLDER = 100
BuildTextures.MAX_ENTRIES_PER_ICON_FOLDER = 500

--Split the icon texture array at entries where there are more than 500 entries
local function CheckTexturesArrayAndSplitIcons()
	local iconTextures = ARRAY_TEXTURES["esoui"]["art"]["icons"]
--FCOit = iconTextures
    if iconTextures == nil then return end
	local iconTexturesSplit = {}
--FCOits = iconTexturesSplit
	local cnt = 0
	local subArrayNum = 0
    local maxValues = BuildTextures.MAX_ENTRIES_PER_ICON_FOLDER or 500
	for textureKey, texturePath in pairs(iconTextures) do
        local splitNow = ((cnt % maxValues) == 0) or false
		--Split the array after the maximum values allowed?
        if (cnt == 0 and subArrayNum == 0) or splitNow then
        	subArrayNum = subArrayNum + 1
            iconTexturesSplit[tostring(subArrayNum)] = {}
        end
    	cnt = cnt + 1
        iconTexturesSplit[tostring(subArrayNum)][textureKey] = texturePath
    end
    if iconTexturesSplit ~= nil and subArrayNum > 0 then
        ARRAY_TEXTURES["esoui"]["art"]["icons"] = nil
        ARRAY_TEXTURES["esoui"]["art"]["icons"] = iconTexturesSplit
    end
end

local function BuildTexturesArray(splitAlphabetically)
    splitAlphabetically = splitAlphabetically or false
d("[BuildTextures - START] splitAlphabetically: " ..tostring(splitAlphabetically))
	if BuildTextures.RAW_TEXTURES ~= nil then
		ARRAY_TEXTURES = {}
                --Split the texture array at the / delimiter in order to get the different folder names, and the file name with .dds at the end
                local function Explode(div, str)
                    if (div=='') then return false end
                    local pos,arr = 0,{}
                    for st,sp in function() return string.find(str,div,pos,true) end do
                        table.insert(arr,string.sub(str,pos,st-1))
                        pos = sp + 1
                    end
                    table.insert(arr,string.sub(str,pos))
                    return arr
                end

                --Check each texture path + name, split it at the delimiter / and build the array for the SavedVariables, that will be used within the addon TextureIt
                --as variable "TEXTUREIT_TEXTURES"
                for index, texturePath in ipairs(BuildTextures.RAW_TEXTURES) do
                    local path = Explode("/", texturePath)
                    local depth1, depth2, depth3, depth4, depth5, depth6, depth7, depth8, depth9, depth10
                    local isFile
                    local firstLetter

                    for depth, folder in ipairs(path) do

				isFile = string.sub(folder, -4) == ".dds"
                --Get the first letter of the filename
                if isFile then
                    --Get the first char of the folder string
                    firstLetter = string.sub(folder, 1, 1)
                else
                    firstLetter = ""
                end

				if depth == 1 then
					depth1 = folder
                    if not ARRAY_TEXTURES[depth1] then ARRAY_TEXTURES[depth1] = {} end
                    if splitAlphabetically and firstLetter ~= "" then
                        if not ARRAY_TEXTURES[depth1][firstLetter] then ARRAY_TEXTURES[depth1][firstLetter] = {} end
                    end
				elseif depth == 2 then
					depth2 = folder
					if isFile then
						depth2 = string.sub(depth2, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2] then ARRAY_TEXTURES[depth1][depth2] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][firstLetter] then ARRAY_TEXTURES[depth1][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][firstLetter][depth2] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2] = texturePath
                        end
					else
						if not ARRAY_TEXTURES[depth1][depth2] then ARRAY_TEXTURES[depth1][depth2] = {} end
					end
				elseif depth == 3 then
					depth3 = folder
					if isFile then
						depth3 = string.sub(depth3, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3] then ARRAY_TEXTURES[depth1][depth2][depth3] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][firstLetter] then ARRAY_TEXTURES[depth1][depth2][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][firstLetter][depth3] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3] = texturePath
                        end
					else
						if not ARRAY_TEXTURES[depth1][depth2][depth3] then ARRAY_TEXTURES[depth1][depth2][depth3] = {} end
					end
				elseif depth == 4 then
					depth4 = folder
					if isFile then
						depth4 = string.sub(depth4, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
--d(">" .. tostring(depth1) .. "/" .. tostring(depth2) .. "/" .. tostring(depth3) .. "/" .. tostring(depth4) .. "/" .. tostring(firstLetter))
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][firstLetter][depth4] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4] = texturePath
                        end
                    else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4] = {} end
                    end
				elseif depth == 5 then
					depth5 = folder
					if isFile then
						depth5 = string.sub(depth5, 1, -5)
--d(">" .. tostring(depth1) .. "/" .. tostring(depth2) .. "/" .. tostring(depth3) .. "/" .. tostring(depth4) .. "/" .. tostring(depth5) .. "/" .. tostring(firstLetter))
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][firstLetter][depth5] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5] = texturePath
                        end
                    else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5] = {} end
                    end
				elseif depth == 6 then
					depth6 = folder
					if isFile then
						depth6 = string.sub(depth6, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][firstLetter][depth6] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6] = texturePath
                        end
                    else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6] = {} end
					end
				elseif depth == 7 then
					depth7 = folder
					if isFile then
						depth7 = string.sub(depth7, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][firstLetter][depth7] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7] = texturePath
                        end
                    else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7] = {} end
					end
				elseif depth == 8 then
					depth8 = folder
					if isFile then
						depth8 = string.sub(depth8, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][firstLetter][depth8] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8] = texturePath
                        end
					else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8] = {} end
                    end
				elseif depth == 9 then
					depth9 = folder
					if isFile then
						depth9 = string.sub(depth9, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][firstLetter][depth9] = texturePath
                        else
    						ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9] = texturePath
                        end
					else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9] = {} end
                    end
                elseif depth == 10 then
                    d("Hit 10th depth. Consider adding a 11th depth")
                    depth10 = folder
                    if isFile then
                        depth10 = string.sub(depth10, 1, -5)
                        --if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][depth10] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][depth10] = {} end
                        if splitAlphabetically and firstLetter ~= "" then
                            if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][firstLetter] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][firstLetter] = {} end
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][firstLetter][depth10] = texturePath
                        else
                            ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][depth10] = texturePath
                        end
                    else
                        if not ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][depth10] then ARRAY_TEXTURES[depth1][depth2][depth3][depth4][depth5][depth6][depth7][depth8][depth9][depth10] = {} end
                    end
                end
			end

		end
        if not splitAlphabetically then
            --Split the ICON folder so there are not more than 500 entries in each subfolder
            CheckTexturesArrayAndSplitIcons()
        end
        d("[BuildTextures - END] |cFF0000Please do a manual /reloadui to save the data into the SavedVariables file 'BuildTextures.lua'!|r")
        d(">>> Copy the contents of the SavedVars table 'ARRAY_TEXTURES' to the addon 'TextureIt' filename '/core/TextureIt_TexturePaths.lua''s array 'TEXTUREIT_TEXTURES'!")
    else
		d("!!! [BuildTextures - ERROR] RAW_TEXTURES input table not found !!!")
	end
end

--The command handler function
local function command_handler(args)
    if (args ~= nil and (args == false or args == true or args == "0" or args == "1" or args == "false" or args == "true")) then
        if args == 0 or args == 1 then
            if args == 1 then args = true
            elseif args == 0 then args = false end
        elseif args == "false" or args == "true" then
            if args == "true" then args = true
            elseif args == "false" then args = false end
        else
            args = args or false
        end
        BuildTexturesArray(args)
    else
        BuildTexturesArray(false)
    end
end

--Register the chat slash commands to build the texture array
--You'll manually need to do a /reloadui to save it to the savedvariablee!
SLASH_COMMANDS["/buildtextures"] = command_handler
SLASH_COMMANDS["/btex"] = command_handler
